<?php
/* $Id: helper.php 14 2009-05-10 21:56:44Z mir $ */
require_once 'config.inc.php';

$pwd = WEB_ROOT;
if ($pwd[strlen($pwd)-1] == '/')
    $pwd = substr($pwd, 0, -1);

function getServerUrl() {
    $protocol = 'http://';
    $server = ($_SERVER['SERVER_PORT'] != 80)? $_SERVER['SERVER_NAME'].':'.$_SERVER['SERVER_PORT'] : $_SERVER['SERVER_NAME'];
    return $protocol.$server.WEB_ROOT;
}

function getServerUri() {
    return TOP_FOLDER;
}

function createKey($key) {
    $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
    $public = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_DEV_RANDOM);
    $ks = mcrypt_enc_get_key_size($td);
    mcrypt_module_close($td);

    /* Create key */
    $secret = substr($key, 0, $ks);
    return array($secret, $public);
}

function encode($text) {
    /* Intialize encryption */
    $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
    $iv = $_SESSION['authenticate']->getPublicKey();
    $key = $_SESSION['authenticate']->getSecretKey();

    mcrypt_generic_init($td, $key, $iv);

    /* Encrypt data */
    $encrypted = mcrypt_generic($td, $text);

    /* Terminate encryption handler */
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);

    return $encrypted;
}

function decode($text) {
    $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
    $iv = $_SESSION['authenticate']->getPublicKey();
    $key = $_SESSION['authenticate']->getSecretKey();

    /* Initialize encryption module for decryption */
    mcrypt_generic_init($td, $key, $iv);

    /* Decrypt encrypted string */
    $decrypted = mdecrypt_generic($td, $text);

    /* Terminate decryption handle and close module */
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);

    return $decrypted;
}

function implode_cal($text) {
    $infos = split("\n", $text);
    foreach ($infos as $info) {
        $row = split('=', $info);
        $result[$row[0]] = $row[1];
    }
    return $result;
}

function ReportError ($msg)
{
    // be sure that the supplied parameter is a string and not empty
    if (empty ($msg) || !is_string ($msg)) {
        throw new ErrorException ('Invalid parameter supplied to ReportError', 0, E_ERROR);
    }

    // retrieve error settings
    $display    = strtolower(ini_get('display_errors'));
    $log        = strtolower(ini_get('log_errors'));

    // check if we're displaying errors
    if ($display === 'on' || $display === '1' || $display === 1 || $display === 'true' || $display === true) {
        echo $msg;
    }
    else {
        print '<?xml version="1.0" encoding="utf-8"?>
        <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
            "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
        <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
            <head>
                <title>Web Calendar</title>
                <link rel="stylesheet" type="text/css"
                    href="'.$pwd.'/css/top_level.css" />
                <link rel="shortcut icon"
                    href="'.$pwd.'/pixmaps/favicon.ico" />
            </head>
            <body>
                <div id="error_msg">
                    <p>
                        The application has triggered an error which is not
                        recoverable. The execution has therefore been cancelled.
                        <br/><br/>
                        The error is logged and the webmaster will handle
                        the error in due time.
                        <br/><br/>
                        To help fix the application you are welcome to notify
                        the <a href="mailto:'.$_SERVER['SERVER_ADMIN'].'
                        ?subject='.TITLE.': error report['.
                        $_SERVER['SERVER_NAME'].']">webmaster</a>
                        by email with a detailed description containing the
                        following information:
                        <br/><br/>
                        1) What did you do just before this message occurred<br/>
                        2) What did you expect to happen<br/>
                        3) Your browser name and version number.<br/>
                    </p>
                </div>
            </body>
        </html>';
    }

    // check if we're logging errors
    if ($log === 'on' || $log === '1' || $log === 1 || $log === 'true' || $log === true) {
        $result = error_log ($msg);

        // check for error while logging
        if (!$result) {
            throw new ErrorException ('Attempt to write message to error log failed in ReportError', 0, E_ERROR);
        }
    }
}

//Begin main function definition
function ErrorsAsExceptions ($level, $msg, $fileName, $lineNumber)
{
    // do nothing if error reporting is turned off
    if (error_reporting() === 0) {
        return;
    }

    // be sure received error is supposed to be reported
    if (error_reporting() & $level) {
        try {
            // report error to appropriate channels
            ReportError(/*$reportMsg*/$msg);
        }
        catch (ErrorException $e) {
            // ignore errors while reporting
        }

        // go ahead and throw the exception
        throw new ErrorException($msg, 0, $level, $fileName, $lineNumber);
    }
}

set_error_handler('ErrorsAsExceptions');

?>
